#!/usr/bin/env python
#encoding: utf-8

import time
import logging
import sys,os
sys.path.append(os.path.split(os.path.realpath(__file__))[0])
from aliyun.log.logexception import LogException
from aliyun.log.logitem import LogItem
from aliyun.log.logclient import LogClient
from aliyun.log.getlogsrequest import GetLogsRequest
from aliyun.log.putlogsrequest import PutLogsRequest
from aliyun.log.listtopicsrequest import ListTopicsRequest
from aliyun.log.listlogstoresrequest import ListLogstoresRequest
from aliyun.log.gethistogramsrequest import GetHistogramsRequest
from aliyun.log.index_config import *
from aliyun.log.logtail_config_detail import *
from aliyun.log.machine_group_detail import *
from aliyun.log.acl_config import *
from aliyun.log.log_logs_pb2 import LogGroup
import random
import math
def get_random_md5():
    s = "";
    for i in range(0,32):
        tmp = hex(random.randrange(0,16))
        tmp = tmp[2:len(tmp)]
        if len(tmp) == 1:
            tmp = "0"+tmp
        s += tmp;
    return s;
logGroup = LogGroup()
logCount = 0
random.seed((int)(time.time()))
md5 = get_random_md5().upper();
packageCount = 0;
debug_total_lines = 0;
groupCount = 0;
def report_status(mobile,weight,bid,uid,sid):
    print mobile,weight,bid,uid,sid
def unlock_bike(t,bikeid,ele,locktype,openlocktype,userid,gender,age,request_id):
    global logGroup
    global project
    global  logstore
    locktypeStr = "normal_lock";
    if(locktype == 1):
        locktypeStr = "smart_lock"
    genderStr  =  "female";
    if gender == 1:
        genderStr = "male"
    log = logGroup.Logs.add()
    opStatus = "ok"
    if random.randrange(0,1000)<100:
        opStatus = "fail"
    all_ips = ["222.205.0.","222.126.194.","223.99.1.","223.0.0.","222.126.245.","222.40.18.","221.183.30.1","222.126.172.","222.50.202.","222.192.184."]
    contents = [
            ("bikeid" , str(bikeid)),
            ("battery" , str(ele)),
            ("lock_type" , str(locktypeStr)),
            ("open_lock",str(openlocktype)),
            ("op_result","ok"),
            ("op","unlock"),
            ("userid",str(userid)),
            ("gender",genderStr),
            ("age",str(age)),
            ("latency",str(random.randrange(10,30))),
            ("request_id",request_id),
            ("longitude",str(120.1870031807+random.uniform(-0.1,0.1))),
            ("latitude",str(30.2999911433+random.uniform(-0.01,0.01))),
            ("ip",all_ips[random.randrange(0,10)] + str(random.randrange(0,255)))
            ]
    global debug_total_lines
    debug_total_lines +=1
    for key,value in contents:
        content = log.Contents.add()
        content.Key = key
        content.Value = value
    
    log.Time = t;
    source = ""
    global logCount
    logCount +=1
    if logCount > 1000:
        logGroup.Topic = "v6"
        tag = logGroup.LogTags.add()
        tag.Key = "__pack_id__"
        global md5
        global groupCount
        tag.Value =  md5[:16]+"-"+hex(groupCount).upper()[2:]
        groupCount +=1
        response = client.put_logs_fast(project,logstore,logGroup)
        logGroup = LogGroup()
        logCount = 0
def report_bug(t,bikeid,locktype,userid,bug,battery):
    locktypeStr = "normal_lock";
    if(locktype == 1):
        locktypeStr = "smart_lock"
    contents = [
            ("bikeid",str(bikeid)),
            ("op","reportbug"),
            ("bug",bug),
            ("battery",str(battery)),
            ("lock_type",locktypeStr),
            ("userid",str(userid))
            ]
    log = logGroup.Logs.add()
    for key,value in contents:
        content = log.Contents.add()
        content.Key = key
        content.Value = value
    
    log.Time = t;



def add_lock_bike_and_pay( t,bikeid,ele,mile,time,usingEle,userid,gender,age,request_id):
    global project
    global  logstore
    payR = random.randrange(0,1000)
    if payR < 500:
        pay = "account_balance"
    elif payR < 900:
        pay = "alipay"
    else:
        pay = "weixin"
    money = (time / 60*30 +1) * 0.5
    genderStr  =  "female";
    if gender == 1:
        genderStr = "male"
    all_ips = ["222.205.0.","222.126.194.","223.99.1.","223.0.0.","222.126.245.","222.40.18.","221.183.30.1","222.126.172.","222.50.202.","222.192.184."]
    contents = [
            ("bikeid" , str(bikeid)),
            ("battery" , str(ele)),
            ("op_result","ok"),
            ("op","lock"),
            ("userid",str(userid)),
            ("ride_time",str(time)),
            ("ride_mile",str(mile)),
            ("used_battery",str(usingEle)),
            ("gender",str(genderStr)),
            ("age",str(age)),
            ("pay_channel",str(pay)),
            ("money",str(money)),
            ("latency",str(random.randrange(10,100))),
            ("request_id",request_id),
            ("longitude",str(120.1870031807+random.uniform(-0.1,0.1))),
            ("latitude",str(30.2999911433+random.uniform(-0.01,0.01))),
            ("ip",all_ips[random.randrange(0,10)] + str(random.randrange(0,255)))
            ]
    global logGroup
    log = logGroup.Logs.add()
    for key,value in contents:
        content = log.Contents.add()
        content.Key = key
        content.Value = value
    log.Time = int(t);
    source = ""
    global logCount
    logCount +=1
    if logCount > 1000:
        logGroup.Topic = "v6"
        tag = logGroup.LogTags.add()
        tag.Key = "__pack_id__"
        global md5
        global groupCount
        tag.Value =  md5[:16]+"-"+hex(groupCount).upper()[2:]
        groupCount +=1
        response = client.put_logs_fast(project,logstore,logGroup)
        logGroup = LogGroup()
        logCount = 0


def aliyun_log_sample(requestId):
    try:
        inner_aliyun_log_sample(requestId,1)
    except Exception as e:
        print e

def sls_unlock(context):
    logger = logging.getLogger()
    logger.info("unlock start")
    try:
        inner_aliyun_log_sample(context,1)
    except Exception as e:
        print e
    logger.info("unlock end")

def sls_lock(context):
    logger = logging.getLogger()
    logger.info("lock start")
    try:
        inner_aliyun_log_sample(context,2)
    except Exception as e:
        print e
    logger.info("lock end")



project = "yunqi-demo"
logstore = "ebike"
client  = None
def inner_aliyun_log_sample(context,reqType):
    endpoint = "cn-shanghai.log.aliyuncs.com"

    global project
    global logstore
    if context is not None:   
        creds = context.credentials
        accessKeyId =context.credentials.access_key_id; 
        accessKey = context.credentials.access_key_secret
        token= context.credentials.security_token
        request_id = context.request_id
    else:
        accessKeyId = "LTAIePAKwjo95MBi"
        accessKey = "AaEQEM75DOi6iEKfy1rggBR1bzctoe"
        token = None
        request_id = ""
        project = "trip-demo"

    
   
    
   # logstore = "sls_operation_log"
    global client
    client = LogClient(endpoint, accessKeyId, accessKey,token)
    needCreate = True
    try:
        listProjectRes = client.list_project();
        listProjectRes.log_print();
        if len(listProjectRes.get_projects()) > 0:
            project = listProjectRes.get_projects()[0]["projectName"]
            needCreate = False
    except Exception as e:
        print e
    try:
        if needCreate == True:
            t = time.time()
            nowTime = lambda:int(round(t * 1000))
            project += "-"+str(nowTime())
            print "create project",project
            client.create_project(project,"yunqi demo")
    except Exception as e:
        print e;
    try:
        client.create_logstore(project,logstore,7,2)
    except Exception as e:
        print e;
    try:
        client.create_logstore(project,"fc-debug-log",7,2)
    except Exception as e:
        print e;

    line_config = IndexLineConfig([" ", "\t", "\n", ","], False )
    key_config_list = {}
    key_config_list["bikeid"] = IndexKeyConfig([","], True,"text",True)
    key_config_list["battery"] = IndexKeyConfig([","], True,"double",True)
    key_config_list["age"] = IndexKeyConfig([","], True,"long",True)
    key_config_list["op_result"] = IndexKeyConfig([","], True,"text",True)
    key_config_list["op"] = IndexKeyConfig([","], True,"text",True)
    key_config_list["userid"] = IndexKeyConfig([","], True,"long",True)
    key_config_list["ride_time"] = IndexKeyConfig([","], True,"double",True)
    key_config_list["latency"] = IndexKeyConfig([","], True,"double",True)
    key_config_list["ride_mile"] = IndexKeyConfig([","], True,"double",True)
    key_config_list["used_battery"] = IndexKeyConfig([","], True,"double",True)
    key_config_list["gender"] = IndexKeyConfig([","], True,"text",True)
    key_config_list["pay_channel"] = IndexKeyConfig([","], True,"text",True)
    key_config_list["money"] = IndexKeyConfig([","], True,"double",True)
    key_config_list["lock_type"] = IndexKeyConfig([","], True,"text",True)
    key_config_list["open_lock"] = IndexKeyConfig([","], True,"text",True)
    key_config_list["bug"] = IndexKeyConfig([","], True,"text",True)
    key_config_list["request_id"] = IndexKeyConfig([","], True,"text",True)
    key_config_list["ip"] = IndexKeyConfig([","], True,"text",True)
    key_config_list["longitude"] = IndexKeyConfig([","], True,"double",True)
    key_config_list["latitude"] = IndexKeyConfig([","], True,"double",True)
    index_detail = IndexConfig(7, line_config, key_config_list)
    try:
        res = client.create_index(project,logstore,index_detail)
    except Exception as e:
        print e
    try:
        line_config = IndexLineConfig([","," ","'","\"",";","=","(",")","[","]","{","}","?","@","\n","\t"], False )
        index_detail = IndexConfig(7,line_config,{});
        res = client.create_index(project,"fc-debug-log",index_detail)
    except Exception as e:
        print e

        #        0  1   2   3    4  5   6   7    8       9     10   11  12,  13   14

    bikeInUse = [100,100,100,100,100,100,100,10000,15000,15000,5000,5000,8000,7000,5000,5000 ,5000,8000,15000,10000,5000,4000,3000,1000]
    bikeInUse = [100,100,100,100,100,100,100,1000,2500,2500,1000,700,800,700,500,500 ,500,1000,2500,2000,1000,500,300,200]
    for i in range(0,len(bikeInUse)):
        bikeInUse[i] /=100
    totalBike = 100
    bikeIsInUse = range(0,totalBike)
    bikeElectric = range(0,totalBike)
    bikeUsingElectric = range(0,totalBike)
    
    bikeElectricLastRun = range(0,totalBike)
    bikeUsingUserId = range(0,totalBike)
    bikeAvalibleTime = range(0,totalBike)
    bikeLockType = range(0,totalBike)
    bikeMile = range(0,totalBike)
    bikeUsingTime = range(0,totalBike)

    elePerMile = 10000;
    totalPassengers = 1000
    passengerAgePoint = range(0,totalPassengers)
    passengersLastRun = range(0,totalPassengers)
    passengersGender = range(0,totalPassengers)
    #passenger type 0 middle man
    # 1   middle woman
    # 2 
    for i in range(0,totalPassengers):
        passengerAgePoint[i] = int(abs(random.randrange(18,60)))
        passengersLastRun [i] = 0;
        if(random.randrange(0,1000) < 600):
            passengersGender [i]  = 1; #0 female 1 male
        else:
            passengersGender [i]  = 0; #0 female 1 male
    for i in range(0,totalBike):
        bikeIsInUse[i] = 0;
        bikeElectric [i] = 200000;
        if i < 200 :
            bikeElectric[i] -= i*2000
        if bikeElectric[i] < 0:
            bikeElectric[i] = 200000
        bikeAvalibleTime [i] = 0;
        bikeUsingUserId [i] = -1;
        if random.randrange(0,1000) < 800:
            bikeLockType[i] = 1;
        else:
            bikeLockType[i] = 0;

    for t in range(0,3600*24):
        hour = t /3600
        bikes = bikeInUse[hour]
    dayEnd = (int)(time.time())
    #dayEnd -= dayEnd % (3600*24)+ 8*3600
    dayBegin = dayEnd - 24*3600
    print dayBegin, dayEnd 
    bikeUsed = 0;
    for t in range(dayBegin,dayEnd,600):
        hour = (t %(24*3600)/3600 + 8) % 24
        maxRun = bikeInUse[hour];
        avaliable_bikes = []
        
        for i in range(0, totalBike):
            now  = t
            if bikeAvalibleTime[i] < now-600:
                if bikeElectric[i] > 1000:
                    avaliable_bikes.append(i)
            elif bikeAvalibleTime[i] < now+600 and now < dayEnd - 600:
                uid = bikeUsingUserId [i];
                bikeElectric[i] -=bikeUsingElectric[i]
                add_lock_bike_and_pay(bikeAvalibleTime[i],i,bikeElectric[i],bikeMile[i],bikeUsingTime[i],bikeUsingElectric[i],uid,passengersGender[uid],passengerAgePoint[uid],request_id);
            else:
                continue
        for i  in range(totalBike - len(avaliable_bikes),maxRun):
            #if (random.randrange(0,1000)> 500):
            #    continue
            bikeId1 = random.randrange(0,len(avaliable_bikes))
            bikeId = avaliable_bikes[bikeId1]
            running_mile = abs(random.uniform(1,5))
            if running_mile > 5:
                running_mile = 5;
            elif running_mile < 0.5:
                running_mile = 0.5
            speedPerHour = abs(random.uniform(5,15))
            if speedPerHour > 15:
                speedPerHour = 15;
            if speedPerHour < 5:
                speedPerHour = 5
            usingTime = running_mile*1.0/speedPerHour*60
            userId = random.randrange(0,totalPassengers)
            if (t-dayBegin)  >= (dayEnd - dayBegin)/2 and (t-dayBegin)  < (600+(dayEnd - dayBegin)/2):
                userId = 458
            bikeUsingUserId[bikeId] = userId
            startTime = t + random.randrange(0,60)
            bikeAvalibleTime[bikeId] = startTime  + usingTime*60;
            #print startTime,usingTime,bikeAvalibleTime[bikeId]
            openLockType = "manual"
            bikeMile [bikeId] = running_mile
            bikeUsingTime [bikeId] = usingTime
            bikeUsingElectric[bikeId] = running_mile * 1000*(0.9+random.uniform(0,0.2))
            if bikeLockType[bikeId] == 1:
                openType = random.randrange(0,3)
                if openType == 1:
                    openLockType = "bluetooth"
                elif openType == 2:
                    openLockType = "sms"
            
            unlock_bike(startTime,bikeId,bikeElectric[bikeId],bikeLockType[bikeId], openLockType,userId,passengersGender[userId],passengerAgePoint[userId],request_id)

 #   bugCount=random.randrange(0,5)
 #   bugtype = ["battery_low","tire_broke","other","unlock_fail"]
 #   for i in range(0,bugCount):
 #       bikeid=random.randrange(0,totalBike)
 #       bug = bugtype[bikeid% len(bugtype)]
 #       if bug == "battery_low":
 #           ele = random.randrange(1000,2000)
 #       else:
 #           ele = bikeElectric[bikeid]
 #       report_bug(int(time.time()),bikeid,bikeLockType[bikeid],random.randrange(0,totalPassengers),bug,ele)
    global logGroup
    global logCount
    if logCount > 0:
        logGroup.Topic = "v6"
        tag = logGroup.LogTags.add()
        tag.Key = "__pack_id__"
        global md5
        global groupCount
        tag.Value =  md5[:16]+"-"+hex(groupCount).upper()[2:]
        groupCount +=1

        response = client.put_logs_fast(project,logstore,logGroup)
    
    global debug_total_lines
    print debug_total_lines

#            break

    #client.delete_logstore(project, logstore)
if __name__ == "__main__":
    aliyun_log_sample(None)
